#ifndef _box_
#define _box_

#include "player.hpp"
#include "rocket.hpp"
#include "enemy.hpp" 	
#include "boss.hpp"
#include "wall.hpp"
#include "powerup.hpp"
#include "definitions.hpp"

using std::cout; using std::endl;

typedef std::list<bullet> b_list;
typedef std::list<enemy> e_list;
typedef std::vector<wall> w_vec;
typedef std::list<rocket> r_list;

class Box
{
	
	public:
	Box() { clear(); }
	~Box() {}
	
	int matrix[R][C];                                                 		 //the position matrix
	void refresh(b_list&, b_list&, e_list&, player&, int &score, boss& boss1,w_vec &walls, b_list & powerups,r_list&);  	 //empties, uploads, kills, empties again, uploads again matrix
	void print();                                                   		  //prints the position matrix
	void clear();                                                    		 //fills matrix with 0's
	void destroy(int X, int Y, b_list & bullets, b_list& bombs, e_list& enemies, b_list & powerups,r_list&);     //destroys bullets, bombs and enemies in (X,Y)
	
	private:	                                                   
	void upload(b_list & bullets, b_list& bombs, e_list& enemies, player& player1, boss& boss1,w_vec &walls, b_list & powerups,r_list&);    //fills matrix with objects id's
	void kill(b_list & bullets, b_list& bombs, e_list& enemies, int &score, boss& spole,w_vec &walls, b_list & powerups, player & player1,r_list&);           //checks where there's something to destroy
	

};

#endif

